#
# spec file for package amazon-ecs-init
#
# Copyright (c) 2021 SUSE LLC
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


%define short_name amazon-ecs
Name:           amazon-ecs-init
Version:        1.53.0
Release:        150100.4.17.1
Summary:        Amazon EC2 Container Service Initialization
License:        Apache-2.0
Group:          System Environment/Base
URL:            https://github.com/aws/amazon-ecs-init
Source0:        %{name}-%{version}-1.tar.gz
Source1:        %{short_name}.service
Patch0:         reproducible.patch
Patch1:         use-agent-container-built-in-certs.patch
BuildRequires:  go  >= 1.7
BuildRequires:  pkgconfig(systemd)
# We cannot handle cross module dependencies properly, i.e. one module can
# only depend on one other module, instead of having a one to many
# dependency construct. While docker is a hard requirement this cannot be
# expressed here and we use Recommends. AS we want to have openSUSE and SLE
# behave in the same way openSUSE has to suffer the same "brokenness"
Recommends:     docker >= 1.6.0
Requires:       systemd
Provides:       bundled(golang(github.com/Azure/go-ansiterm))
Provides:       bundled(golang(github.com/Azure/go-ansiterm/winterm))
Provides:       bundled(golang(github.com/Microsoft/go-winio))
Provides:       bundled(golang(github.com/NVIDIA/gpu-monitoring-tools/bindings/go/nvml))
Provides:       bundled(golang(github.com/Nvveen/Gotty))
Provides:       bundled(golang(github.com/Sirupsen/logrus))
Provides:       bundled(golang(github.com/aws/aws-sdk-go/aws))
Provides:       bundled(golang(github.com/aws/aws-sdk-go/aws/awserr))
Provides:       bundled(golang(github.com/aws/aws-sdk-go/aws/awsutil))
Provides:       bundled(golang(github.com/aws/aws-sdk-go/aws/client))
Provides:       bundled(golang(github.com/aws/aws-sdk-go/aws/client/metadata))
Provides:       bundled(golang(github.com/aws/aws-sdk-go/aws/corehandlers))
Provides:       bundled(golang(github.com/aws/aws-sdk-go/aws/credentials))
Provides:       bundled(golang(github.com/aws/aws-sdk-go/aws/credentials/ec2rolecreds))
Provides:       bundled(golang(github.com/aws/aws-sdk-go/aws/credentials/endpointcreds))
Provides:       bundled(golang(github.com/aws/aws-sdk-go/aws/credentials/stscreds))
Provides:       bundled(golang(github.com/aws/aws-sdk-go/aws/defaults))
Provides:       bundled(golang(github.com/aws/aws-sdk-go/aws/ec2metadata))
Provides:       bundled(golang(github.com/aws/aws-sdk-go/aws/endpoints))
Provides:       bundled(golang(github.com/aws/aws-sdk-go/aws/request))
Provides:       bundled(golang(github.com/aws/aws-sdk-go/aws/session))
Provides:       bundled(golang(github.com/aws/aws-sdk-go/aws/signer/v4))
Provides:       bundled(golang(github.com/aws/aws-sdk-go/internal/sdkio))
Provides:       bundled(golang(github.com/aws/aws-sdk-go/internal/sdkrand))
Provides:       bundled(golang(github.com/aws/aws-sdk-go/internal/shareddefaults))
Provides:       bundled(golang(github.com/aws/aws-sdk-go/private/protocol))
Provides:       bundled(golang(github.com/aws/aws-sdk-go/private/protocol/query))
Provides:       bundled(golang(github.com/aws/aws-sdk-go/private/protocol/query/queryutil))
Provides:       bundled(golang(github.com/aws/aws-sdk-go/private/protocol/rest))
Provides:       bundled(golang(github.com/aws/aws-sdk-go/private/protocol/restxml))
Provides:       bundled(golang(github.com/aws/aws-sdk-go/private/protocol/xml/xmlutil))
Provides:       bundled(golang(github.com/aws/aws-sdk-go/service/s3))
Provides:       bundled(golang(github.com/aws/aws-sdk-go/service/s3/s3iface))
Provides:       bundled(golang(github.com/aws/aws-sdk-go/service/s3/s3manager))
Provides:       bundled(golang(github.com/aws/aws-sdk-go/service/sts))
Provides:       bundled(golang(github.com/cihub/seelog))
Provides:       bundled(golang(github.com/cihub/seelog/archive))
Provides:       bundled(golang(github.com/cihub/seelog/archive/gzip))
Provides:       bundled(golang(github.com/cihub/seelog/archive/tar))
Provides:       bundled(golang(github.com/cihub/seelog/archive/zip))
Provides:       bundled(golang(github.com/coreos/go-systemd/activation))
Provides:       bundled(golang(github.com/davecgh/go-spew/spew))
Provides:       bundled(golang(github.com/docker/docker/api/types))
Provides:       bundled(golang(github.com/docker/docker/api/types/blkiodev))
Provides:       bundled(golang(github.com/docker/docker/api/types/container))
Provides:       bundled(golang(github.com/docker/docker/api/types/filters))
Provides:       bundled(golang(github.com/docker/docker/api/types/mount))
Provides:       bundled(golang(github.com/docker/docker/api/types/network))
Provides:       bundled(golang(github.com/docker/docker/api/types/registry))
Provides:       bundled(golang(github.com/docker/docker/api/types/strslice))
Provides:       bundled(golang(github.com/docker/docker/api/types/swarm))
Provides:       bundled(golang(github.com/docker/docker/api/types/versions))
Provides:       bundled(golang(github.com/docker/docker/opts))
Provides:       bundled(golang(github.com/docker/docker/pkg/archive))
Provides:       bundled(golang(github.com/docker/docker/pkg/fileutils))
Provides:       bundled(golang(github.com/docker/docker/pkg/homedir))
Provides:       bundled(golang(github.com/docker/docker/pkg/idtools))
Provides:       bundled(golang(github.com/docker/docker/pkg/ioutils))
Provides:       bundled(golang(github.com/docker/docker/pkg/jsonlog))
Provides:       bundled(golang(github.com/docker/docker/pkg/jsonmessage))
Provides:       bundled(golang(github.com/docker/docker/pkg/longpath))
Provides:       bundled(golang(github.com/docker/docker/pkg/mount))
Provides:       bundled(golang(github.com/docker/docker/pkg/pools))
Provides:       bundled(golang(github.com/docker/docker/pkg/promise))
Provides:       bundled(golang(github.com/docker/docker/pkg/stdcopy))
Provides:       bundled(golang(github.com/docker/docker/pkg/system))
Provides:       bundled(golang(github.com/docker/docker/pkg/term))
Provides:       bundled(golang(github.com/docker/docker/pkg/term/windows))
Provides:       bundled(golang(github.com/docker/go-connections/nat))
Provides:       bundled(golang(github.com/docker/go-connections/sockets))
Provides:       bundled(golang(github.com/docker/go-plugins-helpers/sdk))
Provides:       bundled(golang(github.com/docker/go-plugins-helpers/volume))
Provides:       bundled(golang(github.com/docker/go-units))
Provides:       bundled(golang(github.com/fsouza/go-dockerclient))
Provides:       bundled(golang(github.com/go-ini/ini))
Provides:       bundled(golang(github.com/golang/mock/gomock))
Provides:       bundled(golang(github.com/jmespath/go-jmespath))
Provides:       bundled(golang(github.com/opencontainers/go-digest))
Provides:       bundled(golang(github.com/opencontainers/image-spec/specs-go))
Provides:       bundled(golang(github.com/opencontainers/image-spec/specs-go/v1))
Provides:       bundled(golang(github.com/opencontainers/runc/libcontainer/system))
Provides:       bundled(golang(github.com/opencontainers/runc/libcontainer/user))
Provides:       bundled(golang(github.com/pkg/errors))
Provides:       bundled(golang(github.com/pmezard/go-difflib/difflib))
Provides:       bundled(golang(github.com/stretchr/testify/assert))
Provides:       bundled(golang(golang.org/x/net/context))
Provides:       bundled(golang(golang.org/x/net/context/ctxhttp))
Provides:       bundled(golang(golang.org/x/net/proxy))
Provides:       bundled(golang(golang.org/x/sys/unix))
Provides:       bundled(golang(golang.org/x/sys/windows))

BuildRoot:      %{_tmppath}/%{name}-%{version}-build
ExclusiveArch:  x86_64 aarch64

%description
The Amazon EC2 Container Service initialization will start the ECS agent.
The ECS agent runs in a container and is needed to support integration
between the aws-cli ecs command line tool and an instance running in
Amazon EC2.

%prep
%setup -q -n %{name}-%{version}-1
%patch0 -p1
%patch1

%build
export GO111MODULE="auto"
./scripts/gobuild.sh suse
gzip -c scripts/amazon-ecs-init.1 > scripts/amazon-ecs-init.1.gz

%install
install -d -m 755 %{buildroot}/%{_mandir}/man1
install -d -m 755 %{buildroot}/%{_sbindir}
install -d -m 755 %{buildroot}/%{_sysconfdir}/ecs
install -m 644 scripts/amazon-ecs-init.1.gz %{buildroot}/%{_mandir}/man1
install -m 755 amazon-ecs-init %{buildroot}/%{_sbindir}

mkdir -p %{buildroot}/%{_unitdir}
install -m 755 %SOURCE1 %{buildroot}/%{_unitdir}

touch %{buildroot}/%{_sysconfdir}/ecs/ecs.config
touch %{buildroot}/%{_sysconfdir}/ecs/ecs.config.json

mkdir -p %{buildroot}/%{_localstatedir}/cache/ecs
touch %{buildroot}/%{_localstatedir}/cache/ecs/ecs-agent.tar
echo 0 > %{buildroot}/%{_localstatedir}/cache/ecs/state

%files
%defattr(-,root,root,-)
%dir %{_sysconfdir}/ecs
%dir %{_localstatedir}/cache/ecs
%doc CONTRIBUTING.md LICENSE NOTICE README.md
%config(noreplace) %{_sysconfdir}/ecs/ecs.config
%config(noreplace) %{_sysconfdir}/ecs/ecs.config.json
%{_mandir}/man*/*
%{_sbindir}/*
%{_unitdir}/%{short_name}.service
%{_localstatedir}/cache/ecs/ecs-agent.tar
%{_localstatedir}/cache/ecs/state

%pre
%service_add_pre %{short_name}.service

%preun
%service_del_preun %{short_name}.service

%post
%service_add_post %{short_name}.service

%postun
%service_del_postun %{short_name}.service

%changelog
* Wed Jun 23 2021 adrian.glaubitz@suse.com
- Update to version 1.53.0-1 (bsc#1187661, bsc#1187662)
  * Cache Agent version 1.53.0
- from version 1.52.2-2
  * Cache Agent version 1.52.2
  * ecs-anywhere-install: fix incorrect download url when running in cn region
- from version 1.52.2-1
  * Cache Agent version 1.52.2
  * ecs-anywhere-install: remove dependency on gpg key server
  * ecs-anywhere-install: allow sandboxed apt installations
* Wed May 26 2021 rjschwei@suse.com
- Add use-agent-container-built-in-certs.patch to use the built in certs from
  the downloaded agent container
- Update amazon-ecs.service to consider the proper environment files
- Set the cache state to ensure the latest agent container gets pulled
* Wed May 19 2021 rjschwei@suse.com
- Update to version 1.52.1 (bsc#1186239, bsc#1186262)
  + Cache Agent version 1.52.1
  + Add support for ECS EXTERNAL launch type (ECS Anywhere)
* Mon Mar 15 2021 rjschwei@suse.com
- Add info about bundled dependencies in spec
- Fix required go version
- Handle go 1.16 or later by switching GO111MODULE to previous default
* Fri Feb 26 2021 rjschwei@suse.com
- Only build for x86_64 and aarch64
* Tue Feb 16 2021 rjschwei@suse.com
- Update to version 1.50.1 (bsc#1182343, bsc#1182344)
  + Cache Agent version 1.50.1
  + Does not restart ECS Agent when it exits with exit code 5
- For detailed changes between the previous version and this version see
  the included Changelog.md file
* Mon Feb  3 2020 dimstar@opensuse.org
- BuildRequire pkgconfig(systemd) instead of systemd: allow OBS to
  shortcut through the -mini flavors.
* Wed Apr  3 2019 rjschwei@suse.com
- Enable aarch64 build (bsc#1131459)
* Thu Aug 30 2018 bwiedemann@suse.com
- Add reproducible.patch to use constant build path (boo#1062303)
* Tue Jul 17 2018 adrian.glaubitz@suse.com
- Update to version 1.18.0
  + Cache Agent version 1.18.0
  + Add support for regional buckets
  + Bundle ECS Agent tarball in package
  + Download agent based on the partition
  + Mount Docker plugin files dir
* Fri May 25 2018 rjschwei@suse.com
- Modify dependencies to work around module dependency issues in SLE
* Tue May 22 2018 rjschwei@suse.com
- Update to version 1.17.3
  + No upstream changelog
* Thu Nov  3 2016 rjschwei@suse.com
- Service needs to run after we know the network is fully configured
  thus use network-online.target instead of network.target
* Thu Nov  3 2016 rjschwei@suse.com
- Update to version 1.13.0 (bsc#1008298)
  + Cache agent version 1.13.0
- From 1.12.2
  + Cache Agent version 1.12.2
- From 1.12.1
  + Cache Agent version 1.12.1
- From 1.12.0
  + Enable Task IAM Role for containers launched with 'host' network mode
  + Cache Agent version 1.12.0
- From 1.11.1
  + Cache Agent version 1.11.1
- From 1.11.0
  + Enhancement - Support Task IAM Roles feature of Agent
  + Enhancement - Start Agent with host network mode
  + Enhancement - Cache Agent version 1.11.0
  + Enhancement - Add support for Docker 1.11.2
- From 1.10.0
  + Enhancement - Cache Agent version 1.10.0
  + Enhancement - Add support for Docker 1.11.1
- From 1.9.0
  + Enhancement - Cache Agent version 1.9.0
  - From 1.8.2
  + Enhancement - Cache Agent version 1.8.2
- From 1.8.1
  + Enhancement - Cache Agent version 1.8.1
* Wed Jan 27 2016 rjschwei@suse.com
- Update to version 1.7.1 (bsc#963837)
  + remove cgroup_location.patch, system path is integrated in build
    configuration
  + Cache Agent version 1.7.1
- From 1.7.0
  + Cache Agent version 1.7.0
  + Add support for Docker 1.9.1
- From 1.6.0
  + Cache Agent version 1.6.0
  + Updated source dependencies
* Thu Oct  8 2015 rjschwei@suse.com
- Update to version 1.5.0 (bsc#949602)
  + Enhancement - Cache Agent version 1.5.0
  + Enhancement - Improved merge strategy for user-supplied environment
  + Enhancement - Add default supported logging drivers
- Add build switch for SUSE, modify cgroup_location.patch
* Mon Sep 28 2015 rjschwei@suse.com
- Update long description
* Sun Sep 27 2015 rjschwei@suse.com
- Add patch cgroup_location.patch
  + Modify location where the agent looks for cgroup information
* Thu Sep 24 2015 rjschwei@suse.com
- Drop the extra version number
  + Going forward we do not care about picking up -x tarball releases
    the do not contain source changes
* Thu Sep 24 2015 rjschwei@suse.com
- Rename the service file, request from upstream
- Spec file improvements to better match the requirements of the code
* Tue Sep 22 2015 rjschwei@suse.com
- Update to version 1.4.0.2 (1.4.0-2 upstream)
  + Enhancement - Add support for Docker 1.7.1
  + Enhancement: Cache Agent version 1.4.0
  + Feature: Read Docker endpoint from environment variable
    DOCKER_HOST if present
* Tue Sep 22 2015 lchiquitto@suse.de
- Set ExclusiveArch to disable building on architectures not
  supported by Go.
* Mon Aug 10 2015 rjschwei@suse.com
- Include in SLE 12 (fate#319338)
  + Also related to fate#318337
* Mon Aug 10 2015 rjschwei@suse.com
- go is only a BuildRequires as go is completely static and we need
  no runtime bits and pieces
* Wed Aug  5 2015 rjschwei@suse.com
- Use the systemd unit file as source, no need to wrap it in a tarball
* Wed Aug  5 2015 ms@suse.com
- Update to version 1.3.1
  + Added systemd unit script for start/stop
  + Added activation/deactivation of service in spec file
* Mon Jun  1 2015 rjschwei@suse.com
- Initial build
  + Version 1.0-3
  + Not ready for use, still experimenting but need to share to push the
    work forward. The systemd init files need to be sorted out
